//
// common.c
//
#include "common.h"
#include <stdarg.h>
#include <stdio.h>

#define BACKTRACE 0
#if BACKTRACE
    #include <execinfo.h>
#endif

char *strmsg(char *fmt, ...) {
    static char msg[256];
    va_list ap;
    va_start(ap, fmt);
    vsnprintf(msg, sizeof(msg), fmt, ap);
    va_end(ap);
    return msg;
}

static int label = 0;
int label_new() {
    return label++;
}

char *label_str(int label) {
    static char name[15];
    sprintf(name, "label_%03d", label);
    return name;
}

void back_trace() {
#if BACKTRACE
    void *buffer[100];
    int nptrs = backtrace(buffer, 100);
    char **strings = backtrace_symbols(buffer, nptrs);
    for (int i = 0; i < nptrs; i++)
        printf("%s\n", strings[i]);
    free(strings);    
#endif
}
