#ifndef __FUNC__
#define __FUNC__

#include "refobj.h"
#include "stmt.h"
#include "list.h"

typedef struct func {
    refobj_t ref;   //ref is at the beginning of stmt
    void   ( *exec  )(struct func *self);
    void   ( *print )(struct func *self);

    char *fname;    //name of the function
    list_t *ids;    //names of the formal parameters
    stmt_t *body;   //body
} func_t;

extern func_t *func_make(char *fname, list_t *ids, stmt_t *body);

#endif
