#ifndef __PROGRAM__
#define __PROGRAM__
#include "refobj.h"
#include "func.h"
#include "list.h"

typedef struct program {
    refobj_t ref;   //ref is at the beginning of program
    void   ( *exec  )(struct program *self);
    void   ( *print )(struct program *self);

    list_t *vars;   //global variables
    list_t *funcs;  //function definitions
} program_t;

typedef struct func_list_entry {
    func_t *func;
    list_t lst;
} func_list_entry_t;

extern program_t *program_make(list_t *vars, list_t *funcs);
#endif
